# Documentation

> This is a development version of the documentation. The functionality described here may not be included in the current release version. Unreleased functionality may change or be dropped before the next release. Documentation for the release version is available at the [TestCafe website](https://devexpress.github.io/testcafe/documentation/getting-started/).

* [GETTING STARTED](articles/documentation/getting-started/index.md)
* [USING TESTCAFE](articles/documentation/using-testcafe/index.md)
  * [Installing TestCafe](articles/documentation/using-testcafe/installing-testcafe.md)
  * [Command Line Interface](articles/documentation/using-testcafe/command-line-interface.md)
  * [Programming Interface](articles/documentation/using-testcafe/programming-interface/index.md)
    * [TestCafe Class](articles/documentation/using-testcafe/programming-interface/testcafe.md)
    * [BrowserConnection Class](articles/documentation/using-testcafe/programming-interface/browserconnection.md)
    * [Runner Class](articles/documentation/using-testcafe/programming-interface/runner.md)
    * [createTestCafe Factory](articles/documentation/using-testcafe/programming-interface/createtestcafe.md)
  * [Common Concepts](articles/documentation/using-testcafe/common-concepts/index.md)
    * [Browser Support](articles/documentation/using-testcafe/common-concepts/browser-support.md)
    * [Reporters](articles/documentation/using-testcafe/common-concepts/reporters.md)
* [TEST API](articles/documentation/test-api/index.md)
  * [Test Code Structure](articles/documentation/test-api/test-code-structure.md)
  * [Actions](articles/documentation/test-api/actions/index.md)
    * [Click](articles/documentation/test-api/actions/click.md)
    * [Double Click](articles/documentation/test-api/actions/double-click.md)
    * [Right Click](articles/documentation/test-api/actions/right-click.md)
    * [Drag Element](articles/documentation/test-api/actions/drag-element.md)
    * [Hover](articles/documentation/test-api/actions/hover.md)
    * [Select Text](articles/documentation/test-api/actions/select-text.md)
    * [Type Text](articles/documentation/test-api/actions/type-text.md)
    * [Press Key](articles/documentation/test-api/actions/press-key.md)
    * [Navigate](articles/documentation/test-api/actions/navigate.md)
    * [Take Screenshot](articles/documentation/test-api/actions/take-screenshot.md)
    * [Upload](articles/documentation/test-api/actions/upload.md)
    * [Resize Window](articles/documentation/test-api/actions/resize-window.md)
    * [Action Options](articles/documentation/test-api/actions/action-options.md)
  * [Selecting Page Elements](articles/documentation/test-api/selecting-page-elements/index.md)
    * [Selectors](articles/documentation/test-api/selecting-page-elements/selectors.md)
    * [Selector Options](articles/documentation/test-api/selecting-page-elements/selector-options.md)
    * [DOM Node Snapshots](articles/documentation/test-api/selecting-page-elements/dom-node-snapshots.md)
  * [Assertions](articles/documentation/test-api/assertions.md)
  * [Obtaining Data from the Client](articles/documentation/test-api/obtaining-data-from-the-client.md)
  * [Pausing the Test](articles/documentation/test-api/pausing-the-test.md)
  * [Handling Native Dialogs](articles/documentation/test-api/handling-native-dialogs.md)
  * [Working with &lt;iframes&gt;](articles/documentation/test-api/working-with-iframes.md)
  * [A-Z Index](articles/documentation/test-api/a-z-index.md)
* [EXTENDING TESTCAFE](articles/documentation/extending-testcafe/index.md)
  * [Reporter Plugin](articles/documentation/extending-testcafe/reporter-plugin/index.md)
    * [Reporter Methods](articles/documentation/extending-testcafe/reporter-plugin/reporter-methods.md)
    * [Helpers](articles/documentation/extending-testcafe/reporter-plugin/helpers.md)
  * [Browser Provider Plugin](articles/documentation/extending-testcafe/browser-provider-plugin/index.md)
    * [Browser Provider Methods](articles/documentation/extending-testcafe/browser-provider-plugin/browser-provider-methods.md)
* [RECIPES](articles/documentation/recipes/index.md)
  * [Running Tests Using Travis CI and Sauce Labs](articles/documentation/recipes/running-tests-using-travis-ci-and-sauce-labs.md)
